/*************************************************
* Zeus CMD - OpenGL ES Tutorial 12 : Perspective *
* By Grant James (ZEUS)                          *
* http://www.zeuscmd.com                         *
*************************************************/
#pragma comment(lib, "libGLES_CM.lib")

#define GLUTES_STATIC

#include <GLES/glutes.h>
#include <GLES/glues.h>
#include <GLES/glues.c>

int w = 0;
int h = 0;

bool perspective = true;

void init()
{
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClearDepthf(1.0f);
}

void display()
{
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	gluLookAtf(
		0.0f, 0.0f, 2.0f,
		0.0f, 0.0f, 0.0f,
		0.0f, 1.0f, 0.0f);

	glColor4f(1.0f, 0.0f, 0.0f, 1.0f);
	glTranslatef(0.25f, 0.0f, 0.0f);
	glutSolidCube(0.5f);

	glColor4f(0.0f, 1.0f, 0.0f, 1.0f);
	glTranslatef(-0.25f, 0.0f, -1.0f);
	glutSolidCube(0.5f);

	glColor4f(0.0f, 0.0f, 1.0f, 1.0f);
	glTranslatef(-0.25f, 0.0f, -1.0f);
	glutSolidCube(0.5f);
   
	glFlush ();
	glutSwapBuffers();
}

void reshape(int, int);
void keyboard2(int key, int x, int y)
{
	switch(key)
	{
	case GLUT_KEY_UP : exit(0); break;
	}
}

void reshape(int width, int height)
{
	w = width;
	h = height;

	if (!height)
		height = 1;

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	glViewport(0, 0, width, height);

	if (perspective)
		gluPerspectivef(45.0f, 1.0f * width / height, 1.0f, 100.0f);
	else
		glOrthof(-1.0f, 1.0f, -1.0f, 1.0f, -1.0f, 20.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void menu(int entry)
{
	switch(entry)
	{
	case 1 : exit(0); break;
	case 2 :
		perspective = !perspective;
		reshape(w, h);
		glutPostRedisplay();
		break;
	}
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);

	glutCreateWindow("12 - Perspective");

	init();

	glutDisplayFunc(display);
	glutReshapeFunc(reshape);
	glutSpecialFunc(keyboard2);

	glutCreateMenu(menu);
	glutAddMenuEntry("Perspective", 2);
	glutAddMenuEntry("Quit", 1);

	glutAttachMenu(GLUT_LEFT_BUTTON);

	glutMainLoop();

	return 0;
}
